package easyNotify;

import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;
import org.omg.PortableServer.POAPackage.*;


/**
 * Consommateur d'vnements structurs.
 *
 * Attention, il n'y a pas de cration de POA : on utilise celui pass en paramtre.
 **/

public class EasyNotifyStructuredPushConsumer extends EasyNotifyConsumer {



    StructuredProxyPushSupplier structuredProxyPushSupplier;
    StructuredPushConsumerImpl structuredPushConsumerImpl;
    POA poa;
//     POA consumerPOA;

    /**
     * pointeur vers l'objet qui doit recevoir les notifications
     **/
    protected EasyStructuredEventDealer eventDealer;

    public EasyNotifyStructuredPushConsumer(ORB orb, POA poa, EasyStructuredEventDealer eventDealer) throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb);
	completeConstruction(orb, poa, eventDealer);
    }
    
    public EasyNotifyStructuredPushConsumer(ORB orb, POA poa, Property[] initialQoS, Property[] initialAdmin, EasyStructuredEventDealer eventDealer)throws org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, initialQoS, initialAdmin);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPushConsumer(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort, EasyStructuredEventDealer eventDealer) throws org.omg.CORBA.SystemException , org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin{
	super(orb, notificationServiceMachine, notificationServicePort);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPushConsumer(ORB orb, POA poa, int channelId, EasyStructuredEventDealer eventDealer) throws ChannelNotFound, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin {
	super(orb, channelId);
	completeConstruction(orb, poa, eventDealer);
    }

    public EasyNotifyStructuredPushConsumer(org.omg.CORBA.ORB orb, POA poa, String notificationServiceMachine, String notificationServicePort, int channelId, EasyStructuredEventDealer eventDealer) throws org.omg.CORBA.SystemException, org.omg.CosNotification.UnsupportedQoS, org.omg.CosNotification.UnsupportedAdmin, org.omg.CosNotifyChannelAdmin.ChannelNotFound {
	super(orb, notificationServiceMachine, notificationServicePort, channelId);
	completeConstruction(orb, poa, eventDealer);
    }


    private void completeConstruction(org.omg.CORBA.ORB orb, POA poa, EasyStructuredEventDealer eventDealer) {
	this.poa = poa;

	this.eventDealer = eventDealer;

	// cration d'un POA pour la bte
	Policy[] pl = new Policy[2];
	pl[0] = poa.create_lifespan_policy(
		    org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
	pl[1] = poa.create_id_assignment_policy(
	 	    org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);

	// construction de l'objet qui va recevoir les requtes et les
	// faire passer  celui qui doit les traiter
	System.out.println("cration de l'implementation serveur qui rcupere les evenements");
	structuredPushConsumerImpl = new StructuredPushConsumerImpl(orb, poa, eventDealer); 
    }




    public void connect() throws org.omg.CosNotifyChannelAdmin.AdminLimitExceeded, org.omg.CosEventChannelAdmin.AlreadyConnected {
	// partie commune  tous les consommateurs
	System.out.println("Connexion d'un consumer");
	startConnect();


	// partie spcifique  un consommateur de ce type
	ProxySupplier proxySupplier = consumerAdmin.obtain_notification_push_supplier(ClientType.STRUCTURED_EVENT, proxySupplierId);
	structuredProxyPushSupplier = StructuredProxyPushSupplierHelper.narrow(proxySupplier);


	// connexion effective
	try {
	    poa.activate_object(structuredPushConsumerImpl);
	    org.omg.CosNotifyComm.StructuredPushConsumer consumer = structuredPushConsumerImpl._this(orb);
	    structuredProxyPushSupplier.connect_structured_push_consumer(consumer);
	} catch(org.omg.CosEventChannelAdmin.TypeError ex) {
	    System.err.println("Type error.");
	} catch (org.omg.PortableServer.POAPackage.ServantAlreadyActive e) {
	    System.err.println("Servant dj actif");
	} catch (org.omg.PortableServer.POAPackage.WrongPolicy e) {
	    System.err.println("Mauvaise politique");
	}
    }

    
    public void disconnect() {
	System.out.println("Dconnexion");
	structuredProxyPushSupplier.disconnect_structured_push_supplier();
    }


}
	
