/*
 * ClientUI.java
 *
 * Created on 3 dcembre 2001, 11:29
 */

/**
 * Interface graphique de l'application Client.
 * Les mthodes de <i>callbacks</i> sont  implmenter.
 *
 * @author <a href="mailto:anthony.milan@voila.fr">Anthony Milan</a>
 */
public abstract class ClientUI extends javax.swing.JFrame {

    private String euro;




    /** Creates new form ClientUI */
    public ClientUI() {
	euro = Character.isDefined('\u20AC') ? "\u20AC" : "Euro";
        initComponents();
	setTitle("Client salle des ventes");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        barreDeMenu = new javax.swing.JMenuBar();
        menuConnexion = new javax.swing.JMenu();
        menuConnect = new javax.swing.JMenuItem();
        menuRetirer = new javax.swing.JMenuItem();
	menuQuitter = new javax.swing.JMenuItem();
	menuEdit = new javax.swing.JMenu();
	menuCatalogue = new javax.swing.JMenuItem();
	menuParticiper = new javax.swing.JMenuItem();
        scrollCatalogue = new javax.swing.JScrollPane();
        tableCatalogue = new javax.swing.JTable();
        panelSomme = new javax.swing.JPanel();
        sommeDepensee = new javax.swing.JLabel();
	labelSolde = new javax.swing.JLabel();
        panelArticle = new javax.swing.JPanel();
        labelPar = new javax.swing.JLabel();
        labelIdClient = new javax.swing.JLabel();
        labelEnchereCourante = new javax.swing.JLabel();
        labelPrixCourant = new javax.swing.JLabel();
        labelStatut = new javax.swing.JLabel();
        labelLeStatut = new javax.swing.JLabel();
        labelEncherirA = new javax.swing.JLabel();
        textFieldEnchere = new javax.swing.JTextField();
        boutonEncherir = new javax.swing.JButton();
        
        menuConnexion.setText("Connexion");
        
        menuConnect.setText("Connecter");
	menuConnect.setToolTipText("Connection  une salle des ventes...");
        menuConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onConnect(evt);
            }
        });
        
        menuConnexion.add(menuConnect);
        menuRetirer.setText("Dconnecter");
	menuRetirer.setToolTipText("Quitter la salle des ventes...");
	menuRetirer.setEnabled(false);
        menuRetirer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onRetirer();
            }
        });
        
        

	menuConnexion.add(new javax.swing.JSeparator());

	menuQuitter.setText("Quitter");
	menuQuitter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onQuitter();
            }
        });

	menuConnexion.add(menuQuitter);

	menuEdit.setText("Application");

	menuCatalogue.setText("Catalogue...");
	menuCatalogue.setToolTipText("Obtenir le catalogue de la salle des ventes ...");
	menuCatalogue.setEnabled(false);
	menuCatalogue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onCatalogue(evt);
            }
        });

	menuEdit.add(menuCatalogue);

	menuParticiper.setText("Participer...");
	menuParticiper.setToolTipText("Participer  la vente ...");
	menuParticiper.setEnabled(false);
	menuParticiper.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onParticiper(evt);
            }
        });
	
	menuEdit.add(menuParticiper);
	menuEdit.add(menuRetirer);
        barreDeMenu.add(menuConnexion);
        barreDeMenu.add(menuEdit);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        scrollCatalogue.setBorder(new javax.swing.border.TitledBorder("Catalogue"));
        scrollCatalogue.setViewportView(tableCatalogue);
        
        getContentPane().add(scrollCatalogue, java.awt.BorderLayout.CENTER);
        
        panelSomme.setBorder(new javax.swing.border.TitledBorder("Informations finanires"));
	panelSomme.setLayout(new java.awt.GridLayout(2, 2));
	panelSomme.add(new javax.swing.JLabel("Somme dpense :"));
        sommeDepensee.setText("0 "+euro);
        panelSomme.add(sommeDepensee);

	panelSomme.add(new javax.swing.JLabel("Solde :"));
	labelSolde.setText("inconnu");
	panelSomme.add(labelSolde);

        
        getContentPane().add(panelSomme, java.awt.BorderLayout.NORTH);
        
        panelArticle.setLayout(new java.awt.GridLayout(5, 2));
        
        panelArticle.setBorder(new javax.swing.border.TitledBorder("NomArticle"));
        labelPar.setText("Par");
        panelArticle.add(labelPar);
        
        labelIdClient.setText("");
        panelArticle.add(labelIdClient);
        
        labelEnchereCourante.setText("Enchre courante");
        panelArticle.add(labelEnchereCourante);
        
        labelPrixCourant.setText("");
        panelArticle.add(labelPrixCourant);
        
        labelStatut.setText("Statut");
        panelArticle.add(labelStatut);
        
        labelLeStatut.setText("");
        panelArticle.add(labelLeStatut);
        
        labelEncherirA.setText("Enchrir ");
        panelArticle.add(labelEncherirA);
        
        textFieldEnchere.setMinimumSize(new java.awt.Dimension(60, 20));
        textFieldEnchere.setPreferredSize(new java.awt.Dimension(60, 20));
        textFieldEnchere.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onEncherir(evt);
            }
        });
        panelArticle.add(textFieldEnchere);
        
        boutonEncherir.setText("Enchrir");
	boutonEncherir.setEnabled(false);
        boutonEncherir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onEncherir(evt);
            }
        });
        
        panelArticle.add(boutonEncherir);
        
        getContentPane().add(panelArticle, java.awt.BorderLayout.SOUTH);
        
        
        setJMenuBar(barreDeMenu);
        pack();
    }

    protected abstract void onEncherir(java.awt.event.ActionEvent evt);
  

    protected abstract void onConnect(java.awt.event.ActionEvent evt);


    protected abstract void onCatalogue(java.awt.event.ActionEvent evt);

    protected abstract void onParticiper(java.awt.event.ActionEvent evt);

    protected abstract void onRetirer(); 

    protected abstract void onQuitter(); 

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
	onQuitter();
    }
  
  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JMenuBar barreDeMenu;
    protected javax.swing.JMenu menuConnexion;
    protected javax.swing.JMenuItem menuConnect;
    protected javax.swing.JMenuItem menuRetirer;
    protected javax.swing.JMenuItem menuQuitter;
    protected javax.swing.JMenu menuEdit;
    protected javax.swing.JMenuItem menuParticiper;
    protected javax.swing.JMenuItem menuCatalogue;
    protected javax.swing.JScrollPane scrollCatalogue;
    protected javax.swing.JTable tableCatalogue;
    protected javax.swing.JPanel panelSomme;
    protected javax.swing.JLabel sommeDepensee;
    protected javax.swing.JLabel labelSolde;
    protected javax.swing.JPanel panelArticle;
    protected javax.swing.JLabel labelPar;
    protected javax.swing.JLabel labelIdClient;
    protected javax.swing.JLabel labelEnchereCourante;
    protected javax.swing.JLabel labelPrixCourant;
    protected javax.swing.JLabel labelStatut;
    protected javax.swing.JLabel labelLeStatut;
    protected javax.swing.JLabel labelEncherirA;
    protected javax.swing.JTextField textFieldEnchere;
    protected javax.swing.JButton boutonEncherir;
    // End of variables declaration//GEN-END:variables
  
    protected void setArticleCourant(String article) {
	System.out.println("Nouvel article " + article);
        ((javax.swing.border.TitledBorder) panelArticle.getBorder()).setTitle(article);
    }
    
    protected void setPrixCourant(int prix) {
	labelPrixCourant.setText(""+prix+" "+euro);
    }

    protected void setEncherisseurCourant(String nom) {
	labelIdClient.setText(nom);
    }

    protected void setStatutCourant(String s) {
	labelStatut.setText(s);
    }

    protected void setDepense(int somme) {
	sommeDepensee.setText(""+somme+" "+euro);
    }

    protected void setSolde(int somme) {
	labelSolde.setText(""+somme+" "+ euro);
    }

}
