
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import java.io.*;

public class AdministrationPull {

    static void run(ORB orb) {
	try {
	    org.omg.CORBA.Object obj = orb.resolve_initial_references("RootPOA");
	    POA rootPOA = POAHelper.narrow(obj);
	    POAManager manager = rootPOA.the_POAManager();
	    
	    SocialSecurityPull socialSecurity = new SocialSecurityPull(orb, rootPOA);
	    socialSecurity.run();
	    
	    manager.activate();
	    orb.run();
	} catch (Exception e) {
	    e.printStackTrace();
	    System.exit(1);
	}
    }

    public static void main (String[] args) {

	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	

	ORB orb = ORB.init(args, props);

	run(orb);

    }
}
