
import easyNotify.*;

import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import java.util.*;
import java.io.*;

/**
 * une personne gnre des vnements en particulier lis  ses
 * changements d'tat civil.
 *
 * Pour communiquer avec les autres, elle utilise un ORB!
 **/
 
public class Personne {

    final static String NOTIFICATION_SERVICE_MACHINE = "localHost";
    final static String NOTIFICATION_SERVICE_PORT    = "10001";
    final static int CHANEL_ID = 0;

    protected String nom;

    protected ORB orb;

    EasyNotifyStructuredPushSupplier notify;



    /**
     * contruction d'une personne
     *
     * Les rfrences du service de notification sont connues. Si tel
     * n'tait pas le cas, il faudrait les obtenir d'une faon
     * quelconque (passage de paramtres ou fichier de
     * configuration...)
     *
     * ATTENTION, on est dans un cas particulier ici : on suppose que
     * l'on utilise toujours le channel 0 et que ce canal est cr par
     * l'administration
     **/
    public Personne(ORB orb, String nom) {
	this.orb = orb;
	this.nom = nom;
	try {
	    notify = new EasyNotifyStructuredPushSupplier(orb, NOTIFICATION_SERVICE_MACHINE, NOTIFICATION_SERVICE_PORT, CHANEL_ID);
	} catch (Exception e) {
	    // seule exception possible : politique non
	    // supporte. Nous ne prcisons pas la politique,
	    // donc... on n'a pas grer cette exception.
	    //
	    // note : il serait peut tre plus judicieux de catcher
	    // l'exception en question au niveau du
	    // constructeur... pas fait... mea culpa!
	    e.printStackTrace();
	}
    }


    /**
     * ce que fait une personne... si on veut des trucs diffrents, il
     * suffit de surcharger!
     **/
    public void run() {
	try {
	    notify.connect();
	    Thread.sleep(1000);
	    System.out.println("PUSH - "+ nom+ " naissance");
	    notify.push(new MyEvent(orb,  nom, "naissance"));
	    Thread.sleep(2000);
	    System.out.println("PUSH - "+ nom+ " a enfant");
	    notify.push(new MyEvent(orb,  nom, "a enfant"));
	    Thread.sleep(5000);
	    System.out.println("PUSH - "+ nom+ " marillage");
	    notify.push(new MyEvent(orb,  nom, "marillage"));
	    Thread.sleep(1000);
	    System.out.println("PUSH - "+ nom+ " a enfant");
	    notify.push(new MyEvent(orb,  nom, "a enfant"));
	    Thread.sleep(10000);
	    System.out.println("PUSH - "+ nom+ " mort");
	    notify.push(new MyEvent(orb,  nom, "mort"));
	    notify.disconnect();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

}
