
import easyNotify.*;

import org.omg.CosNotification.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotifyChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import java.util.*;
import java.io.*;

/**
 * une personne gnre des vnements en particulier lis  ses
 * changements d'tat civil.
 *
 * Pour communiquer avec les autres, elle utilise un ORB!
 **/
 
public class PersonnePull implements EasyStructuredPullEventDealer {

    final static String NOTIFICATION_SERVICE_MACHINE = "localHost";
    final static String NOTIFICATION_SERVICE_PORT    = "10001";
    final static int CHANEL_ID = 0;
    private MyEvent[] myEvent = null;
    private int inc = 0;

    protected String nom;

    protected ORB orb;

    EasyNotifyStructuredPullSupplier notify;



    /**
     * contruction d'une personne
     *
     * Les rfrences du service de notification sont connues. Si tel
     * n'tait pas le cas, il faudrait les obtenir d'une faon
     * quelconque (passage de paramtres ou fichier de
     * configuration...)
     *
     * ATTENTION, on est dans un cas particulier ici : on suppose que
     * l'on utilise toujours le channel 0 et que ce canal est cr par
     * l'administration
     **/
    public PersonnePull(ORB orb, POA poa, String nom) {
	this.orb = orb;
	this.nom = nom;
	myEvent = new MyEvent [5];
	myEvent[0] = new MyEvent(orb,  nom, "naissance");
	myEvent[1] = new MyEvent(orb,  nom, "a enfant");
	myEvent[2] = new MyEvent(orb,  nom, "marillage");
	myEvent[3] = new MyEvent(orb,  nom, "a enfant");
	myEvent[4] = new MyEvent(orb,  nom, "mort");

	try {
	    notify = new EasyNotifyStructuredPullSupplier(orb, poa, NOTIFICATION_SERVICE_MACHINE, NOTIFICATION_SERVICE_PORT, CHANEL_ID, this);
	} catch (Exception e) {
	    // seule exception possible : politique non
	    // supporte. Nous ne prcisons pas la politique,
	    // donc... on n'a pas grer cette exception.
	    //
	    // note : il serait peut tre plus judicieux de catcher
	    // l'exception en question au niveau du
	    // constructeur... pas fait... mea culpa!
	    e.printStackTrace();
	}
    }


    /**
     * ce que fait une personne... si on veut des trucs diffrents, il
     * suffit de surcharger!
     **/
    public void run() {
	try {
	    notify.connect();
	    Thread.sleep(1000);
	    /*System.out.println("PUSH - "+ nom+ "naissance");
	    notify.push(new MyEvent(orb,  nom, "naissance"));
	    Thread.sleep(20000);
	    System.out.println("PUSH - "+ nom+ "a enfant");
	    notify.push(new MyEvent(orb,  nom, "a enfant"));
	    Thread.sleep(5000);
	    System.out.println("PUSH - "+ nom+ "marillage");
	    notify.push(new MyEvent(orb,  nom, "marillage"));
	    Thread.sleep(1000);
	    System.out.println("PUSH - "+ nom+ "a enfant");
	    notify.push(new MyEvent(orb,  nom, "a enfant"));
	    Thread.sleep(10000);
	    System.out.println("PUSH - "+ nom+ "mort");
	    notify.push(new MyEvent(orb,  nom, "mort"));*/
	    System.out.println("Dconnexion");
	    //notify.disconnect();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    public StructuredEvent try_pull(BooleanHolder has_event) {
	System.out.println("try pull");
	has_event.value = false;
	return (new MyEvent(orb,  nom, "divorce")).toStructuredEvent();
    }

    public StructuredEvent pull() {
	try {
	    System.out.println("pull");
	    Thread.sleep(1000);
	    if (inc == myEvent.length) {
		notify.disconnect();
		System.exit(0);
	    }
	    System.out.println("Invitation de : " + nom+ " pour : " + myEvent[inc].getFieldEvent());
	    return (myEvent[inc++]).toStructuredEvent();
	    //return (new MyEvent(orb,  nom, "marillage")).toStructuredEvent();
	} catch (InterruptedException e) {
	    e.printStackTrace();
	    System.exit(1);
	    return null;
	}
    }
}
