// **********************************************************************
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

import NommageFacile.*;


public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Get "hello" object
	// On va chercher la rfrence sur le service de nommage
	//
	org.omg.CORBA.Object obj;
	String nomObjet = new String("dess14:10000:/sallesDeVentes/salle1");

	obj = EasyNaming.resoudreReferenceObjet(orb, nomObjet);

	Hello hello = HelloHelper.narrow(obj);

	//
	// Main loop
	//
	System.out.println("Enter 'h' for hello, 's' for shutdown or 'x' " +
                           "for exit:");

	int c;

	try
	{
	    String input;
	    do
	    {
		System.out.print("> ");
		java.io.BufferedReader in = new java.io.BufferedReader(
		    new java.io.InputStreamReader(System.in));
		input = in.readLine();

		if(input.equals("h"))
		    hello.say_hello();
                else if(input.equals("s"))
		    hello.shutdown();
	    }
	    while(!input.equals("x"));
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("Can't read from `" + ex.getMessage() + "'");
	    return 1;
	}

	return 0;
    }

    //
    // Standalone program initialization
    //
    public static void
    main(String args[])
    {
	int status = 0;
	org.omg.CORBA.ORB orb = null;

	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

	try
	{
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }

}

